# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "fundsp"
version = "0.23.0"
authors = ["SamiPerttu <Sami.Perttu@gmail.com>"]
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Audio processing and synthesis library."
homepage = "https://github.com/SamiPerttu/fundsp"
readme = "README.md"
keywords = [
    "dsp",
    "audio",
    "synthesizer",
    "sound",
    "no_std",
]
categories = [
    "multimedia::audio",
    "no-std",
]
license = "MIT OR Apache-2.0"
repository = "https://github.com/SamiPerttu/fundsp"

[package.metadata.docs.rs]
all-features = true
rustc-args = [
    "--cfg",
    "docsrs",
]

[features]
default = [
    "std",
    "files",
    "fft",
]
fft = ["dep:fft-convolver"]
files = ["dep:symphonia"]
std = []

[lib]
name = "fundsp"
path = "src/lib.rs"

[[example]]
name = "beep"
path = "examples/beep.rs"

[[example]]
name = "file"
path = "examples/file.rs"

[[example]]
name = "grain"
path = "examples/grain.rs"

[[example]]
name = "grain2"
path = "examples/grain2.rs"

[[example]]
name = "keys"
path = "examples/keys.rs"

[[example]]
name = "live_adsr"
path = "examples/live_adsr.rs"

[[example]]
name = "network"
path = "examples/network.rs"

[[example]]
name = "optimize"
path = "examples/optimize.rs"

[[example]]
name = "peek"
path = "examples/peek.rs"

[[example]]
name = "plot"
path = "examples/plot.rs"

[[example]]
name = "sequence"
path = "examples/sequence.rs"

[[example]]
name = "type"
path = "examples/type.rs"

[[test]]
name = "test_basic"
path = "tests/test_basic.rs"

[[test]]
name = "test_dynamics"
path = "tests/test_dynamics.rs"

[[test]]
name = "test_flow"
path = "tests/test_flow.rs"

[[test]]
name = "test_follow"
path = "tests/test_follow.rs"

[[bench]]
name = "benchmark"
path = "benches/benchmark.rs"
harness = false

[dependencies.dyn-clone]
version = "1.0.20"

[dependencies.fft-convolver]
version = "0.3.0"
optional = true

[dependencies.funutd]
version = "0.16.0"
default-features = false

[dependencies.hashbrown]
version = "0.16.1"

[dependencies.libm]
version = "0.2.15"

[dependencies.microfft]
version = "0.6.0"
features = ["size-32768"]

[dependencies.num-complex]
version = "0.4.6"
features = ["libm"]
default-features = false

[dependencies.numeric-array]
version = "0.6.1"
default-features = false

[dependencies.once_cell]
version = "1.21.3"
features = [
    "race",
    "alloc",
]
default-features = false

[dependencies.resampler]
version = "0.4.0"
features = ["no_std"]

[dependencies.symphonia]
version = "0.5.5"
features = ["all"]
optional = true

[dependencies.thingbuf]
version = "0.1.6"
features = ["alloc"]
default-features = false

[dependencies.tinyvec]
version = "1.10.0"
features = ["alloc"]

[dependencies.wide]
version = "1.1.1"
default-features = false

[dev-dependencies.anyhow]
version = "1.0.89"

[dev-dependencies.assert_no_alloc]
version = "1.1.2"

[dev-dependencies.cpal]
version = "0.17.0"

[dev-dependencies.criterion]
version = "0.8.1"

[dev-dependencies.eframe]
version = "0.33.3"

[dev-dependencies.midi-msg]
version = "0.5.0"

[dev-dependencies.midir]
version = "0.9.1"

[dev-dependencies.plotters]
version = "0.3.7"

[dev-dependencies.rayon]
version = "1.10.0"

[dev-dependencies.read_input]
version = "0.8.6"
